<?php
require_once("includes/teamspeakdisplay.php");

Aseco::registerEvent('onStartup', 'ts2_startup');
Aseco::registerEvent('onNewChallenge', 'ts2_panel_on');
Aseco::registerEvent('onPlayerConnect', 'ts2_panel_on');
Aseco::registerEvent('onEverySecond', 'ts2_update');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'ts2_mania_event');
Aseco::addChatCommand('info', 'ts2 info');

global $ts2,$ts2_counter,$ts2_server_addr, $ts2_update_interval, $ts2_serverport, $ts2_queryport;

#
# EDIT SERVER ADDRESS + PORTS HERE AND DEFINE UPDATE INTERVAL IN SECONDS
#

$ts2_server_addr = "yourserver.com"; 
$ts2_serverport = 8767;
$ts2_queryport = 51234;
$ts2_update_interval = 30;
		
// Initialize
function ts2_startup($aseco, $command)
   {
   global $aseco;
   global $ts2;
   $ts2 = new Teamspeak();
   $ts2->Aseco = $aseco;
   $ts2->Start();
   $ts2->visibility = true;
  }

   
// Callbacks for class
function ts2_update($aseco, $command) {
global $ts2,$ts2_counter,$ts2_update_interval;
$ts2_counter++;
	if ($ts2_counter == $ts2_update_interval ) {
	$ts2->updateServerData();
	$ts2_counter = 0;
	}
}

function ts2_panel_on($aseco, $command) 
	{
	global $ts2;
	$ts2->visibility = true;
	$ts2->panel_on();
	}

function ts2_panel_off($aseco, $command) 
	{
	global $ts2;
	$ts2->visibility = false;
	$ts2->panel_off();
	}


function ts2_mania_event($aseco, $command) {
	global $ts2;
	$login = $command[1];
	$action = $command[2];
	if ( $action == $ts2->manialinkID+1) {
		$ts2->info_on($login);
	}
	
	if ( $action == $ts2->manialinkID+2) {
		$ts2->info_off($login);
	}
	
}

function chat_info($aseco,$command) 
	{
	global $ts2;
	$player = $command['author'];
	$login = $player->login;
	
	$args = explode(' ', strtolower($command['params']), 2);
	$cmd = $args[0];
	
	if ($cmd == 'on') {
		$ts2->info_on($login);
	}
	elseif ($cmd == 'off') {
		$ts2->info_off($login);
	}

	}
// Class
class Teamspeak
	{
	public $aseco;
	public $Server;
	public $tsStats;
	public $manialinkID = 35789;
	public $visibility = true;
		
	function updateServerData() {
	$stats = $this->Ts2->queryTeamspeakServerEx($this->Server);
	if ($stats['queryerror'] == 0) { $this->tsStats = $stats; } else { print "Plugin Teamspeak2: connection error\n"; }
	$this->panel_on();
	}
	
	function Start() {
	global $ts2_server_addr, $ts2_serverport, $ts2_queryport;

	$this->Ts2 = new teamspeakDisplayClass;

    $this->Server = $this->Ts2->getDefaultSettings();
	$this->Server["serveraddress"] = $ts2_server_addr;
	$this->Server["serverudpport"] = $ts2_serverport;
	$this->Server["serverqueryport"] = $ts2_queryport;


   if ($this->Server["serveraddress"] == "") { die("No teamspeak2 server defined in " . $_SERVER["PHP_SELF"] . "<br>\n"); }
   $this->updateServerData();
	}
	
	function panel_off() {
		$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id='.$this->manialinkID.'></manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPage', array($xml, 0, false));
	}

	function panel_on()
	{
			$xml = '<?xml version="1.0" encoding="UTF-8"?>
			<manialinks>
			<manialink id="'.$this->manialinkID.'">
			<frame posn="-64 45 0">
			<quad sizen="3 3" posn="0 0 0.001" image="http://koti.mbnet.fi/reaby/xaseco/images/ts2logo.jpg" action="'.($this->manialinkID+1).'" />
			</frame>
			<frame posn="-61 45 0">
			<quad sizen="6 3" posn="0 0 0.001" style="BgRaceScore2" substyle="BgScores" action="'.($this->manialinkID+1).'"/>
			<format textsize="1"/>';
			$i = 0; 
			unset($message);
			$stats = $this->tsStats;
			$users = $stats["serverinfo"]["server_currentusers"];
			$max = $stats["serverinfo"]["server_maxusers"];
			
			//$message[] = "\$fff TeamSpeak2 status";
			$message[] = "\$fff ".$users." / ".$max;
			 
			foreach ($message as $info) 
				{	 
				$y=-2*$i-0.9;
				$xml .= '<label sizen="30 2" halign="left" posn="1 '.$y.' 0.1" text="'.$info.'"/>';
				$i++;
				}
		 	$xml .='';
			$xml .='
			</frame>
			</manialink>
			</manialinks>';
			
			$this->Aseco->addCall('SendDisplayManialinkPage', array($xml, 0, false));
	
		}
		
		
	function info_on($login)
	{
			global $ts2_server_addr, $ts2_serverport;

		$player = $this->Aseco->server->players->getPlayer($login);
		$style = $player->style;	
		$widths[0] = 1.5;		
		$header = "Teamspeak 2 Status";
		$button = "Close";
		$hsize = $style['HEADER'][0]['TEXTSIZE'][0];
		$bsize = $style['BODY'][0]['TEXTSIZE'][0];
		$lines = 23;
		
		// build manialink header & window
		$xml = '<?xml version="1.0" encoding="UTF-8"?>
			<manialinks>
			<manialink id="'.($this->manialinkID+4).'">
			<frame pos="' . ($widths[0]/2) . ' 0.47 0">' .
		        '<quad size="' . $widths[0] . ' ' . (0.11+$hsize+$lines*$bsize) .
		        '" style="' . $style['WINDOW'][0]['STYLE'][0] .
		        '" substyle="' . $style['WINDOW'][0]['SUBSTYLE'][0] . '"/>' . LF;

		// add header and optional icon
		$xml .= '<quad pos="-' . ($widths[0]/2) . ' -0.01 -0.1" size="' . ($widths[0]-0.02) . ' ' . $hsize .
		        '" halign="center" style="' . $style['HEADER'][0]['STYLE'][0] .
		        '" substyle="' . $style['HEADER'][0]['SUBSTYLE'][0] . '"/>' . LF;
		$isize = $hsize;
			$xml .= '<quad pos="-0.055 -0.045 -0.2" size="' . $isize . ' ' . $isize .
			        '" halign="center" valign="center" image="http://koti.mbnet.fi/reaby/xaseco/images/ts2logo.jpg" />' . LF;
			$xml .= '<label pos="-0.10 -0.025 -0.2" size="' . ($widths[0]-0.12) . ' ' . $hsize .
			        '" halign="left" style="' . $style['HEADER'][0]['TEXTSTYLE'][0] .
			        '" text="' . htmlspecialchars(validateUTF8String($header)) . '"/>' . LF;
		
		// add body
		$xml .= '<quad pos="-' . ($widths[0]/2) . ' -' . (0.02+$hsize) .
		        ' -0.1" size="' . ($widths[0]-0.02) . ' ' . (0.02+$lines*$bsize) .
		        '" halign="center" style="' . $style['BODY'][0]['STYLE'][0] .
		        '" substyle="' . $style['BODY'][0]['SUBSTYLE'][0] . '"/>' . LF;

	//Throw some text
			$cnt = 1; 
			unset($message);
			$stats = $this->tsStats;
			$users = $stats["serverinfo"]["server_currentusers"];
			$max = $stats["serverinfo"]["server_maxusers"];
			$channels = $stats["serverinfo"]["server_currentchannels"];
		
			$message[] .= "\$fff Server: ".$ts2_server_addr;
			$message[] .= "\$fff Users: ".$users." / ".$max;
			$message[] .= "\$fff Channels: ".$channels;
			 
			foreach ($message as $info) 
				{	 
			$xml .= '<label pos="-0.025 -' . ($hsize-0.008+$cnt*$bsize) .
					        ' -0.2" size="' . ($widths[0]-0.04) . ' ' . (0.02+$bsize) .
					        '" halign="left" style="' . $style['BODY'][0]['TEXTSTYLE'][0] .
					        '" text="' . htmlspecialchars(validateUTF8String($info)) . '"/>' . LF; 
			$cnt++;
				}
		//join server button
		$xml .='<frame  pos="-' . ($widths[0]/2) . ' -' . ($hsize-0.008+20*$bsize) .' -0.1">';
		
		$cnt+1;
		$xml .='<label posn="-29 0 0.3" style="CardButtonMedium" text="Join server" url="http://koti.mbnet.fi/reaby/xaseco/ts/gateway.php?server='.$ts2_server_addr.'&amp;port='.$ts2_serverport.'" addplayerid="1"/>';
		//$xml .='<label posn="-29 0 0.3" style="CardButtonMedium" text="Join server" url="http://koti.mbnet.fi/reaby/xaseco/ts/gateway.php?value=Inputvalue" />';
		$xml .='</frame>';

		//draw Teamspeak channelbox
		$xml .='
			<frame  pos="-0.825 -' . ($hsize-0.008+1*$bsize) .' 0.1">
			<quad sizen="40 58" posn="0 0 0.001" style="BgsPlayerCard" substyle="BgPlayerName"/>';
	
		$channellist = $stats["channellist"];
		$playerlist = $stats["playerlist"];
		
		foreach ($channellist as $info) {
		$channel[$info["channelid"]]["name"] = $info["channelname"];		
		}
		
		foreach ($playerlist as $player) {
		$channel[$player["channelid"]]["players"][] = array("name" => $player["playername"], "image" => $player["displayimage"]);		
		}
		
		unset($cnt);
		$cnt = 1; 
		$xml .='<format textsize="1" />';
		foreach ($channel as $info) 
				{ 
				if ($cnt > 20) break;
					$xml .= '<label pos="-0.025 -' . (0.01+$cnt*0.03) . ' -0.2" halign="left" text="$090' . htmlspecialchars(validateUTF8String($info['name'])) . '"/>' . LF; 
					$cnt++;
				
					if ( count($info['players']) > 0 ) {
						foreach ($info['players'] as $players) {
						$xml .= '<label pos="-0.045 -' . (0.01+$cnt*0.03) . ' -0.2" halign="left" text="' . htmlspecialchars(validateUTF8String($players['name'])) . '"/>' . LF; 
						$xml .= '<quad sizen="1.2 1.2" pos="-0.025 -' . (0.01+$cnt*0.03) . ' -0.2" image="http://koti.mbnet.fi/reaby/xaseco/images/player_'.$players['image'] .'.jpg" />';
						$cnt++;
						}
					}
	
			
				}
				
		
		$xml .='</frame>';
	
	    // add button (action "0" = close) & footer
		$xml .= '<quad pos="-' . ($widths[0]/2) . ' -' . (0.04+$hsize+$lines*$bsize) .
		        ' -0.2" size="0.06 0.06" halign="center" style="Icons64x64_1" substyle="Close" action="'.($this->manialinkID+2).'"/>' . LF;
		$xml .= '</frame>';
		$xml = str_replace('{#black}', $style['WINDOW'][0]['BLACKCOLOR'][0], $xml);	
				
		 
		$xml .='
			</manialink>
			</manialinks>';
			
			$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));	
	
	}
	
	function info_off($login) {
		$xml = '<?xml version="1.0" encoding="UTF-8"?><manialinks><manialink id='.($this->manialinkID+4).'></manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));
	}
	
	
} 
	
		
?>
